# Nicked a bunch of this from Hy
# https://github.com/hylang/hy/blob/master/hy/cmdline.py
import argparse
import os
import sys

from scrib import barf, version


def dir_check(thisdir):
	"""
	Checks to see if a dir exists.
	If not, it creates it.
	"""
	if not os.path.exists(thisdir):
		os.makedirs(thisdir)


def cmdline_handler(argv):
	"""
	Parse commands and load appropriately.
	"""
	parser = argparse.ArgumentParser(
		prog="scrib"
	)
	# this will contain the script/program name and any arguments for it.
	parser.add_argument(
		'args',
		nargs=argparse.REMAINDER,
		help=argparse.SUPPRESS
	)
	parser.add_argument(
		'-v',
		'--version',
		action='version',
		dest=getversion(),
		help='Shows the version of scrib'
	)
	options = parser.parse_args(argv[1:])

	# Load registered interfaces or set up defaults
	if len(options.args) < 1:
		usage()

	# User did "scrib <name>"
	try:
		barf.Barf(
			'SAV', os.path.expanduser('~') + '/.scrib/' + options.args[0] +
			' available!'
		)
	except IndexError:
		usage()


def getversion():
	print '%s %s' % (version.__name__, version.__version__)


# entry point for cmd line script "scrib"
def scrib_main():
	sys.exit(cmdline_handler(sys.argv))


def usage():
	"""
	Show API information
	"""
	barf.Barf('MSG', 'Usage: scrib botName', False)
	barf.Barf('MSG', 'Creates default config files for you.', False)
	sys.exit()
